var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.RacerBackend = void 0;
var path = require("path");
var util = require("./util");
var Model_1 = require("./Model/Model");
var Backend = require("sharedb");
var RacerBackend = /** @class */ (function (_super) {
    __extends(RacerBackend, _super);
    function RacerBackend(racer, options) {
        var _this = _super.call(this, options) || this;
        _this.racer = racer;
        _this.modelOptions = options && options.modelOptions;
        _this.on('bundle', function (browserify) {
            var racerPath = path.join(__dirname, 'index.js');
            browserify.require(racerPath, { expose: 'racer' });
        });
        return _this;
    }
    RacerBackend.prototype.createModel = function (options, req) {
        if (this.modelOptions) {
            options = (options) ?
                util.mergeInto(options, this.modelOptions) :
                this.modelOptions;
        }
        var model = new Model_1.RootModel(options);
        this.emit('model', model);
        model.createConnection(this, req);
        return model;
    };
    ;
    RacerBackend.prototype.modelMiddleware = function () {
        var backend = this;
        function modelMiddleware(req, res, next) {
            // Do not add a model to the request if one has been added already
            if (req.model)
                return next();
            // Create a new model for this request
            req.model = backend.createModel({ fetchOnly: true }, req);
            // Close the model when this request ends
            function closeModel() {
                res.removeListener('finish', closeModel);
                res.removeListener('close', closeModel);
                if (req.model)
                    req.model.close();
            }
            res.on('finish', closeModel);
            res.on('close', closeModel);
            next();
        }
        return modelMiddleware;
    };
    ;
    return RacerBackend;
}(Backend));
exports.RacerBackend = RacerBackend;
function getModelUndefined() { }
