import { type Model } from './Model';
import { Doc } from './Doc';
import { Callback, Path } from '../types';
export declare class LocalDoc extends Doc {
    constructor(model: Model, collectionName: string, id: string, data: any);
    _updateCollectionData(): void;
    create(value: any, cb?: Callback): void;
    set(segments: Path, value: any, cb?: Callback): any;
    del(segments: Path, cb?: Callback): any;
    increment(segments: any, byNumber: any, cb?: Callback): any;
    push(segments: Path, value: unknown, cb?: Callback): any;
    unshift(segments: Path, value: unknown, cb?: Callback): any;
    insert(segments: Path, index: number, values: any, cb?: Callback): any;
    pop(segments: Path, cb?: Callback): any;
    shift(segments: Path, cb?: Callback): any;
    remove(segments: Path, index: number, howMany: number, cb?: Callback): any;
    move(segments: any, from: any, to: any, howMany: any, cb?: Callback): any;
    stringInsert(segments: any, index: any, value: any, cb?: Callback): any;
    stringRemove(segments: Path[], index: number, howMany: number, cb?: Callback): any;
    get(segments?: Path): any;
    /**
     * @param {Array} segments is the array representing a path
     * @param {Function} fn(node, key) applies a mutation on node[key]
     * @return {Object} returns the return value of fn(node, key)
     */
    _createImplied(segments: any, fn: any): any;
    _apply(segments: any, fn: any, cb?: Callback): any;
    _validatedApply(segments: any, validate: any, fn: any, cb?: Callback): any;
    _arrayApply(segments: any, fn: any, cb?: Callback): any;
}
