import { type Context } from './contexts';
import { RacerBackend } from '../Backend';
import { type Connection } from './connection';
import { type ModelData } from './collections';
export type UUID = string;
export type DefualtType = unknown;
declare module './Model' {
    interface DebugOptions {
        debugMutations?: boolean;
        disableSubmit?: boolean;
        remoteMutations?: boolean;
    }
    interface ModelOptions {
        debug?: DebugOptions;
        fetchOnly?: boolean;
        unloadDelay?: number;
        bundleTimeout?: number;
    }
    type ErrorCallback = (err?: Error) => void;
}
type ModelInitFunction = (instance: RootModel, options: ModelOptions) => void;
export declare class Model<T = DefualtType> {
    static INITS: ModelInitFunction[];
    ChildModel: typeof ChildModel;
    debug: DebugOptions;
    root: RootModel;
    data: T;
    _at: string;
    _context: Context;
    _eventContext: number | null;
    _events: [];
    _maxListeners: number;
    _pass: any;
    _preventCompose: boolean;
    _silent: boolean;
    id(): UUID;
    _child(): ChildModel<T>;
}
export declare class RootModel extends Model<ModelData> {
    backend: RacerBackend;
    connection: Connection;
    constructor(options?: ModelOptions);
}
export declare class ChildModel<T = DefualtType> extends Model<T> {
    constructor(model: Model<T>);
}
export {};
