/**
 * RemoteDoc adapts the ShareJS operation protocol to Racer's mutator
 * interface.
 *
 * 1. It maps Racer's mutator methods to outgoing ShareJS operations.
 * 2. It maps incoming ShareJS operations to Racer events.
 */
import { Doc } from './Doc';
import { type Collection } from './collections';
import { type Model } from './Model';
export declare class RemoteDoc extends Doc {
    debugMutations: boolean;
    shareDoc: any;
    constructor(model: Model, collectionName: string, id: string, snapshot: any, collection: Collection);
    _initShareDoc(): void;
    _updateCollectionData(): void;
    create(value: any, cb: any): void;
    set(segments: any, value: any, cb: any): any;
    del(segments: any, cb: any): any;
    increment(segments: any, byNumber: any, cb: any): any;
    push(segments: any, value: any, cb: any): any;
    unshift(segments: any, value: any, cb: any): any;
    insert(segments: any, index: any, values: any, cb: any): any;
    pop(segments: any, cb: any): any;
    shift(segments: any, cb: any): any;
    remove(segments: any, index: any, howMany: any, cb: any): any;
    move(segments: any, from: any, to: any, howMany: any, cb: any): any;
    stringInsert(segments: any, index: any, value: any, cb: any): any;
    stringRemove(segments: any, index: any, howMany: any, cb: any): any;
    subtypeSubmit(segments: any, subtype: any, subtypeOp: any, cb: any): any;
    get(segments?: string[]): any;
    _createImplied(segments: any): any;
    _arrayApply(segments: any, fn: any, cb: any): any;
    _onOp(op: any): void;
}
