import type { Path, PathLike } from '../types';
import { ModelData } from './collections';
declare module './Model' {
    interface Model<T> {
        at(): ChildModel<T>;
        at<S = unknown>(subpath: PathLike): ChildModel<S>;
        isPath(subpath: PathLike): boolean;
        leaf(path: string): string;
        parent(levels?: number): Model;
        path(subpath?: PathLike): string;
        scope(): ChildModel<ModelData>;
        scope<S = unknown>(subpath: Path): ChildModel<S>;
        _splitPath(subpath: PathLike): string[];
    }
}
