import { Racer } from './Racer';
import * as util from './util';
import type { ShareDBOptions } from 'sharedb';
import { RacerBackend } from './Backend';
import { RootModel, type ModelOptions } from './Model';
export { Query } from './Model/Query';
export { Model, ChildModel, ModelData, type UUID, type Subscribable, type DefualtType, type ModelOptions } from './Model';
export { Context } from './Model/contexts';
export { type ModelOnEventMap, type ModelEvent, ChangeEvent, InsertEvent, LoadEvent, MoveEvent, RemoveEvent, UnloadEvent } from './Model/events';
export type { Callback, ReadonlyDeep, Path, PathLike, PathSegment, Primitive } from './types';
export type { CollectionData } from './Model/collections';
export * as util from './util';
declare const use: typeof util.use, serverUse: typeof util.serverUse;
export type BackendOptions = {
    modelOptions?: ModelOptions;
} & ShareDBOptions;
export { Racer, RacerBackend, RootModel, use, serverUse, };
export declare const racer: Racer;
export declare function createModel(data?: any): RootModel;
export declare function createBackend(options?: BackendOptions): RacerBackend;
